/* very simple preprocessor:
   can only treat 
        #define NAME
	#ifdef  NAME
	#ifndef NAME
	#else
	#endif
   #ifdef/#ifndef cannot be nested
*/


#include <stdio.h>
#include <ctype.h>

typedef enum {
    DEFINE,
    IFDEF,
    IFNDEF,
    ELSE,
    ENDIF,
    TEXT
  }TypLine;


int nb_mac=0;
char mac[1024][32];


static void Get_Macro_Name(char *str,char *macro)

{
 while(*str==' ')
     str++;

 while(isalnum(*str) || *str=='_')
     *macro++ = *str++;

 *macro='\0';
}




static TypLine Get_Typeof_Line(char *str,char *macro)

{
 if (*str!='#')
     return TEXT;

 if (strncmp(str,"#define ",8)==0)
    {
     Get_Macro_Name(str+8,macro);
     return IFDEF;
    }

 if (strncmp(str,"#ifdef ",7)==0)
    {
     Get_Macro_Name(str+7,macro);
     return IFDEF;
    }

 if (strncmp(str,"#ifndef ",8)==0)
    {
     Get_Macro_Name(str+8,macro);
     return IFNDEF;
    }

 if (strncmp(str,"#else",5)==0)
     return ELSE;

 if (strncmp(str,"#endif",6)==0)
     return ENDIF;

 return TEXT;
}



static void Add_Macro(char *macro)

{
 strcpy(mac[nb_mac++],macro);
}


static int Exist_Macro(char *macro)

{
 int i;

 for(i=0;i<nb_mac;i++)
     if (strcmp(mac[i],macro)==0)
         return 1;

 return 0;
}





main(int argc,char *argv[])

{
 FILE *f=fopen(argv[1],"r");
 char  str[1024];
 char  macro[64];
 int   to_write=1;

 while(argc>2)
     Add_Macro(argv[--argc]);

#if 0
 for(argc=0;argc<nb_mac;argc++)
     puts(mac[argc]);
#endif


 for(;;)
    {
     if (fgets(str,sizeof(str),f)==NULL)
         break;

     switch (Get_Typeof_Line(str,macro))
        {
         case DEFINE:
             Add_Macro(macro);
             break;

         case IFDEF:
             if (!Exist_Macro(macro))
                 to_write=0;
             break;

         case IFNDEF:
             if (Exist_Macro(macro))
                 to_write=0;
             break;

         case ELSE:
             to_write=1-to_write;
             break;

         case ENDIF:
             to_write=1;
             break;

         default:
	     if (to_write)
                 fputs(str,stdout);
             break;
        }
    }

 fclose(f);
 return 0;
}
