/*--------------------------------------------------*/
/* Benchmark clp(FD)             INRIA Rocquencourt */
/*                                                  */
/* Name  : queens.pl                                */
/* Title : N-queens problem                         */
/*--------------------------------------------------*/
:- main([top]).


queens(N,L):-
	fd_vector_max(N),
	length(L,N),
	domain(L,1,N),
	safe(L),
	labelingff(L).


safe([]).

safe([X|L]):-
	noattack(L,X,1),
	safe(L).


noattack([],_,_).

noattack([Y|L],X,I):-
	diff(X,Y,I),
	I1 is I+1,
	noattack(L,X,I1).


diff(X,Y,I):-
	X in -{val(Y)} & -{val(Y)-I} & -{val(Y)+I},
	Y in -{val(X)} & -{val(X)-I} & -{val(X)+I}.



:- public start/2.

start([L],[NX]):-
	number_atom(N,NX), 
	queens(N,L).

